> For the complete documentation index, see [llms.txt](https://docs.thingsup.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.thingsup.io/actions/mqtt-commandresponse-action.md).

# MQTT CommandResponse Action

This provides a way to publish MQTT Message based on event. Before adding MQTT CommandResponse Action, user has to define a [**MQTT Connection**](/connections/mqtt-connection.md). User need to provide following parameters.

#### PublishTopic

* &#x20;User need to provide MQTT Topic on which data will be published.

#### SubscribeTopic

User need to provide MQTT Topic on which data will be received.

#### QoS

MQTT QoS value. Default is 1.

#### Function

* Javascript code to build mqtt message.
* "tx\_topic","rx\_topic","message" and "payload" objects are available in this code, function can be used to set message body and topic from payload before sending to MQTT.
* Setting tx\_topic and rx\_topic here overrides already defined PublishTopic and SubscribeTopic respectively.

```
//Example 1

message = payload;
tx_topic = "somenewtopic"; 
rx_topic = "someothertopic";
```

#### ResponseFunction

* Javascript code to validate received message.
* "tx\_topic","rx\_topic","rx\_message" and "tx\_message" objects are available in this code, keeping rx\_message non null will result in success response of action and assigning rx\_message to null will result in action failure.
* This function will execute for each message till success or timeout.

```
// Example 1

if(rx_message.id != tx_message.id ){
rx_message = null; 
}
```

#### Timeout

Maximum time expected in milliseconds for MQTT Response. Default value is 2000. Range is 1000 to 5000.

#### Connection ID

User need to provide a Connection ID of MQTT connection.

![Add MQTT CommandResponse Action](/files/Vf9icTmYA8tBFochpHx4)

Please note the following points:

{% hint style="info" %}

* "payload" object is supplied from Action Trigger like Rules, Action Command etc.
  {% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.thingsup.io/actions/mqtt-commandresponse-action.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
